#!/usr/bin/env node
/*!
 * gitmars v7.0.0-beta.18
 * 这是一个git工作流工具
 * (c) 2021-2024 saqqdy<https://github.com/saqqdy> 
 * Released under the MIT License.
 */
import { program } from 'commander';
import { sendGroupMessage } from '@gitmars/core';
import { createArgs } from '@gitmars/utils';
import lang from './common/local.mjs';
import { cmdConfig } from './conf/postmsg.mjs';

const { t } = lang;
const { args, options } = cmdConfig;
program.name("gitm postmsg").usage("<message> [-u --url [url]]").description(t("Send group message"));
if (args.length > 0)
  program.arguments(createArgs(args));
options.forEach((o) => {
  program.option(o.flags, o.description, o.defaultValue);
});
program.action((message, opt) => {
  sendGroupMessage(message, opt.url || "");
});
program.parse(process.argv);
